/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Julia.xs. Do not edit this file, edit Julia.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Julia.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

typedef struct Math_Fractal_Julia {
    double limit;
    unsigned int max_iter;
    double x_const;
    double y_const;
    double x_min;
    double y_min;
    double x_max;
    double y_max;
    unsigned int width;
    unsigned int height;
} Math_Fractal_Julia;

unsigned int _point(Math_Fractal_Julia *j, unsigned int x, unsigned int y) {
    unsigned int n;
    double x1, y1, x2, y2, xtemp;
    n = 0;
    x1 = x * (j->x_max - j->x_min) / j->width  + j->x_min;
    y1 = y * (j->y_max - j->y_min) / j->height + j->y_min;
    while (++n < j->max_iter) {
        x2 = x1 * x1;
        y2 = y1 * y1;
        if (x2 + y2 > j->limit) {
            break;
        }
        xtemp = x2 - y2 + j->x_const;
        y1 = 2 * x1 * y1 + j->y_const;
        x1 = xtemp;
    }
    if (n == j->max_iter) {
        n = 0;
    }
    return n;
}

static Math_Fractal_Julia julia = {
    5,       /* limit */
    600,     /* max_iter */
    0.0,     /* x_const */
    0.0,     /* y_const */
    -2.2,    /* x_min */
    -1.1,    /* y_min */
    1.0,     /* x_max */
    1.1,     /* y_max */
    640,     /* width */
    480      /* height */
};

#line 64 "Julia.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 208 "Julia.c"

XS_EUPXS(XS_Math__Fractal__Julia__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char*	CLASS = (char *)SvPV_nolen(ST(0))
;
	Math_Fractal_Julia *	RETVAL;
#line 61 "Julia.xs"
        Newx(RETVAL, 1, Math_Fractal_Julia);
        RETVAL->limit    = julia.limit;
        RETVAL->max_iter = julia.max_iter;
        RETVAL->x_const  = julia.x_const;
        RETVAL->y_const  = julia.y_const;
        RETVAL->x_min    = julia.x_min;
        RETVAL->y_min    = julia.y_min;
        RETVAL->x_max    = julia.x_max;
        RETVAL->y_max    = julia.y_max;
        RETVAL->width    = julia.width;
        RETVAL->height   = julia.height;
#line 232 "Julia.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, CLASS, (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Fractal__Julia_set_max_iter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia_set_max_iter)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, max_iter");
    {
	Math_Fractal_Julia *	self;
	unsigned int	max_iter = (unsigned int)SvUV(ST(1))
;
	unsigned int	RETVAL;
	dXSTARG;

    if (SvROK(ST(0))) {
        if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG)) {
            self = (Math_Fractal_Julia *)SvIV((SV *)SvRV(ST(0)));
        } else {
            Perl_croak(aTHX_ "%s -- %s is not a blessed SV reference",
                "Math::Fractal::Julia::julia_set_max_iter()", "self");
            XSRETURN_UNDEF;
        }
    } else if (SvPOK(ST(0))) {
        if (sv_derived_from(ST(0), "Math::Fractal::Julia")) {
            /* julia is defined in Julia.xs */
            self = &julia;
        } else {
            Perl_croak(aTHX_ "%s -- %s is not derived from %s",
                "Math::Fractal::Julia::julia_set_max_iter()", "self", "Math::Fractal::Julia");
            XSRETURN_UNDEF;
        }
    } else {
        Perl_croak(aTHX_ "%s -- %s is not the correct type",
            "Math::Fractal::Julia::julia_set_max_iter()", "self");
        XSRETURN_UNDEF;
    }
;
#line 80 "Julia.xs"
        self->max_iter = max_iter;
        RETVAL = self->max_iter;
#line 283 "Julia.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Fractal__Julia_set_limit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia_set_limit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, limit");
    {
	Math_Fractal_Julia *	self;
	double	limit = (double)SvNV(ST(1))
;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0))) {
        if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG)) {
            self = (Math_Fractal_Julia *)SvIV((SV *)SvRV(ST(0)));
        } else {
            Perl_croak(aTHX_ "%s -- %s is not a blessed SV reference",
                "Math::Fractal::Julia::julia_set_limit()", "self");
            XSRETURN_UNDEF;
        }
    } else if (SvPOK(ST(0))) {
        if (sv_derived_from(ST(0), "Math::Fractal::Julia")) {
            /* julia is defined in Julia.xs */
            self = &julia;
        } else {
            Perl_croak(aTHX_ "%s -- %s is not derived from %s",
                "Math::Fractal::Julia::julia_set_limit()", "self", "Math::Fractal::Julia");
            XSRETURN_UNDEF;
        }
    } else {
        Perl_croak(aTHX_ "%s -- %s is not the correct type",
            "Math::Fractal::Julia::julia_set_limit()", "self");
        XSRETURN_UNDEF;
    }
;
#line 90 "Julia.xs"
        self->limit = limit;
        RETVAL = self->limit;
#line 330 "Julia.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Fractal__Julia_set_bounds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia_set_bounds)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "self, x_min, y_min, x_max, y_max, width, height");
    {
	Math_Fractal_Julia *	self;
	double	x_min = (double)SvNV(ST(1))
;
	double	y_min = (double)SvNV(ST(2))
;
	double	x_max = (double)SvNV(ST(3))
;
	double	y_max = (double)SvNV(ST(4))
;
	unsigned int	width = (unsigned int)SvUV(ST(5))
;
	unsigned int	height = (unsigned int)SvUV(ST(6))
;

    if (SvROK(ST(0))) {
        if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG)) {
            self = (Math_Fractal_Julia *)SvIV((SV *)SvRV(ST(0)));
        } else {
            Perl_croak(aTHX_ "%s -- %s is not a blessed SV reference",
                "Math::Fractal::Julia::julia_set_bounds()", "self");
            XSRETURN_UNDEF;
        }
    } else if (SvPOK(ST(0))) {
        if (sv_derived_from(ST(0), "Math::Fractal::Julia")) {
            /* julia is defined in Julia.xs */
            self = &julia;
        } else {
            Perl_croak(aTHX_ "%s -- %s is not derived from %s",
                "Math::Fractal::Julia::julia_set_bounds()", "self", "Math::Fractal::Julia");
            XSRETURN_UNDEF;
        }
    } else {
        Perl_croak(aTHX_ "%s -- %s is not the correct type",
            "Math::Fractal::Julia::julia_set_bounds()", "self");
        XSRETURN_UNDEF;
    }
;
#line 105 "Julia.xs"
        self->x_min = x_min;
        self->y_min = y_min;
        self->x_max = x_max;
        self->y_max = y_max;
        self->width = width;
        self->height = height;
#line 389 "Julia.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Fractal__Julia_set_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia_set_constant)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, x_const, y_const");
    {
	Math_Fractal_Julia *	self;
	double	x_const = (double)SvNV(ST(1))
;
	double	y_const = (double)SvNV(ST(2))
;

    if (SvROK(ST(0))) {
        if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG)) {
            self = (Math_Fractal_Julia *)SvIV((SV *)SvRV(ST(0)));
        } else {
            Perl_croak(aTHX_ "%s -- %s is not a blessed SV reference",
                "Math::Fractal::Julia::julia_set_constant()", "self");
            XSRETURN_UNDEF;
        }
    } else if (SvPOK(ST(0))) {
        if (sv_derived_from(ST(0), "Math::Fractal::Julia")) {
            /* julia is defined in Julia.xs */
            self = &julia;
        } else {
            Perl_croak(aTHX_ "%s -- %s is not derived from %s",
                "Math::Fractal::Julia::julia_set_constant()", "self", "Math::Fractal::Julia");
            XSRETURN_UNDEF;
        }
    } else {
        Perl_croak(aTHX_ "%s -- %s is not the correct type",
            "Math::Fractal::Julia::julia_set_constant()", "self");
        XSRETURN_UNDEF;
    }
;
#line 118 "Julia.xs"
        self->x_const = x_const;
        self->y_const = y_const;
#line 434 "Julia.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Fractal__Julia_point); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia_point)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, x, y");
    {
	Math_Fractal_Julia *	self;
	unsigned int	x = (unsigned int)SvUV(ST(1))
;
	unsigned int	y = (unsigned int)SvUV(ST(2))
;
	double	RETVAL;
	dXSTARG;

    if (SvROK(ST(0))) {
        if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG)) {
            self = (Math_Fractal_Julia *)SvIV((SV *)SvRV(ST(0)));
        } else {
            Perl_croak(aTHX_ "%s -- %s is not a blessed SV reference",
                "Math::Fractal::Julia::julia_point()", "self");
            XSRETURN_UNDEF;
        }
    } else if (SvPOK(ST(0))) {
        if (sv_derived_from(ST(0), "Math::Fractal::Julia")) {
            /* julia is defined in Julia.xs */
            self = &julia;
        } else {
            Perl_croak(aTHX_ "%s -- %s is not derived from %s",
                "Math::Fractal::Julia::julia_point()", "self", "Math::Fractal::Julia");
            XSRETURN_UNDEF;
        }
    } else {
        Perl_croak(aTHX_ "%s -- %s is not the correct type",
            "Math::Fractal::Julia::julia_point()", "self");
        XSRETURN_UNDEF;
    }
;
#line 127 "Julia.xs"
        RETVAL = _point(self, x, y);
#line 480 "Julia.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Fractal__Julia_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Fractal__Julia_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Math_Fractal_Julia *	self;

    if (SvROK(ST(0))) {
        if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG)) {
            self = (Math_Fractal_Julia *)SvIV((SV *)SvRV(ST(0)));
        } else {
            Perl_croak(aTHX_ "%s -- %s is not a blessed SV reference",
                "Math::Fractal::Julia::julia_DESTROY()", "self");
            XSRETURN_UNDEF;
        }
    } else if (SvPOK(ST(0))) {
        if (sv_derived_from(ST(0), "Math::Fractal::Julia")) {
            /* julia is defined in Julia.xs */
            self = &julia;
        } else {
            Perl_croak(aTHX_ "%s -- %s is not derived from %s",
                "Math::Fractal::Julia::julia_DESTROY()", "self", "Math::Fractal::Julia");
            XSRETURN_UNDEF;
        }
    } else {
        Perl_croak(aTHX_ "%s -- %s is not the correct type",
            "Math::Fractal::Julia::julia_DESTROY()", "self");
        XSRETURN_UNDEF;
    }
;
#line 135 "Julia.xs"
        Safefree(self);
#line 522 "Julia.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__Fractal__Julia); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Fractal__Julia)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Math::Fractal::Julia::_new", XS_Math__Fractal__Julia__new, file, "$");
        (void)newXSproto_portable("Math::Fractal::Julia::set_max_iter", XS_Math__Fractal__Julia_set_max_iter, file, "$$");
        (void)newXSproto_portable("Math::Fractal::Julia::set_limit", XS_Math__Fractal__Julia_set_limit, file, "$$");
        (void)newXSproto_portable("Math::Fractal::Julia::set_bounds", XS_Math__Fractal__Julia_set_bounds, file, "$$$$$$$");
        (void)newXSproto_portable("Math::Fractal::Julia::set_constant", XS_Math__Fractal__Julia_set_constant, file, "$$$");
        (void)newXSproto_portable("Math::Fractal::Julia::point", XS_Math__Fractal__Julia_point, file, "$$$");
        (void)newXSproto_portable("Math::Fractal::Julia::DESTROY", XS_Math__Fractal__Julia_DESTROY, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
